;***************************************************************************************************************

;This software is provided in an AS IS condition,NO WARRANTIES in any form apply to this software.

; picmicrolab.com 9.11.2017
;***************************************************************************************************************
;
;Interfacing MAX7219  with PIC16F876 microcontroller
;
;--------------------------------------------------------------------------------------------------------------	
		LIST 	P=PIC16F876A
		include	P16f876A.inc
        ;include	test.asm

 __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _LVP_OFF & _DEBUG_OFF & _CPD_OFF



	    org		0x00
reset:	goto start
	    org		0x04

SendDataH EQU 0x21
SendDataL EQU 0x20

start:

	bsf			STATUS, RP0
	bcf			STATUS, RP1

	clrf		TRISC
	;clrf		TRISD

	movlw		0x07;PORTB is  Input - 3 Lower bits
	movwf		TRISB

	bcf			STATUS, RP0
	movlw		0x00 ;	Clear Ports
	movwf		PORTC
	;movwf		PORTD
movlw 0xFF
movwf SendDataH

movlw 0x55
movwf SendDataL



;bsf PORTC,0x00
;-------------------------------------------------------
movlw 0xFC ;Shutdown Register - Normal Operation
movwf SendDataH

movlw 0xFF
movwf SendDataL
call SendDataMax7219
;-------------------------------------------------------
;-------------------------------------------------------
movlw 0xFC ;Decode Mode - No decode for digits 0-7
movwf SendDataH

movlw 0xFF
movwf SendDataL
call SendDataMax7219
;-------------------------------------------------------
LOOP:
;------------------------Show 0-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x7E ;Show 0 - No DP
movwf SendDataL
call SendDataMax7219
;------------------------------------------------------
call delay
;------------------------Show 1-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x30 ;Show 1 - No DP
movwf SendDataL
call SendDataMax7219
;------------------------------------------------------
call delay
;------------------------Show 2-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x6d ;Show 2 - No DP
movwf SendDataL
call SendDataMax7219
;------------------------------------------------------
call delay
;------------------------Show 3-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x79 ;Show 3 - No DP
movwf SendDataL
call SendDataMax7219
;------------------------------------------------------
call delay
;------------------------Show 4-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x33 ;Show 4 - No DP
movwf SendDataL
call SendDataMax7219
;-----------------------------------------------------
call delay
;------------------------Show 5-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x5b ;Show 5 - No DP
movwf SendDataL
call SendDataMax7219
;-----------------------------------------------------
call delay
;------------------------Show 6-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x5f ;Show 6 - No DP
movwf SendDataL
call SendDataMax7219
;-----------------------------------------------------
call delay
;------------------------Show 7-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x70 ;Show 7 - No DP
movwf SendDataL
call SendDataMax7219
;-----------------------------------------------------
call delay
;------------------------Show 8-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x7f ;Show 8 - No DP
movwf SendDataL
call SendDataMax7219
;-----------------------------------------------------
call delay
;------------------------Show 9-----------------------
movlw 0xF1 ;Digit 0 Data
movwf SendDataH

movlw 0x7b ;Show 6 - No DP
movwf SendDataL
call SendDataMax7219
;-----------------------------------------------------
call delay

goto LOOP
;goto	LOOP





SendDataMax7219:
;-------------------------------------Send High Byte-------------------------------------
;--------------------Test Bit 7---------------------
btfss SendDataH,0x07
bcf PORTC,0x00
btfsc SendDataH,0x07
bsf PORTC,0x00
;---------------------Clock---------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 6---------------------
btfss SendDataH,0x06
bcf PORTC,0x00
btfsc SendDataH,0x06
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 5---------------------
btfss SendDataH,0x05
bcf PORTC,0x00
btfsc SendDataH,0x05
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 4---------------------
btfss SendDataH,0x04
bcf PORTC,0x00
btfsc SendDataH,0x04
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 3---------------------
btfss SendDataH,0x03
bcf PORTC,0x00
btfsc SendDataH,0x03
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 2---------------------
btfss SendDataH,0x02
bcf PORTC,0x00
btfsc SendDataH,0x02
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 1---------------------
btfss SendDataH,0x01
bcf PORTC,0x00
btfsc SendDataH,0x01
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 0---------------------
btfss SendDataH,0x00
bcf PORTC,0x00
btfsc SendDataH,0x00
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01

;-------------------------------------Send Low Byte-------------------------------------

;--------------------Test Bit 7---------------------
btfss SendDataL,0x07
bcf PORTC,0x00
btfsc SendDataL,0x07
bsf PORTC,0x00
;---------------------Clock---------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 6---------------------
btfss SendDataL,0x06
bcf PORTC,0x00
btfsc SendDataL,0x06
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 5---------------------
btfss SendDataL,0x05
bcf PORTC,0x00
btfsc SendDataL,0x05
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 4---------------------
btfss SendDataL,0x04
bcf PORTC,0x00
btfsc SendDataL,0x04
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 3---------------------
btfss SendDataL,0x03
bcf PORTC,0x00
btfsc SendDataL,0x03
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 2---------------------
btfss SendDataL,0x02
bcf PORTC,0x00
btfsc SendDataL,0x02
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 1---------------------
btfss SendDataL,0x01
bcf PORTC,0x00
btfsc SendDataL,0x01
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01
;--------------------Test Bit 0---------------------
btfss SendDataL,0x00
bcf PORTC,0x00
btfsc SendDataL,0x00
bsf PORTC,0x00
;---------------------------------------------------
call delay
bsf PORTC,0x01
call delay
bcf PORTC,0x01

;----------------------------Load 16 Bit-----------------------------
call delay
bsf PORTC,0x02
call delay
bcf PORTC,0x02

return
;goto	LOOP
;-----------------------------------------------------

delay:	
				
		movlw		0x02		
		movwf		0x53

CONT:	movlw		0x80		
		movwf		0x51
CONT1:	movlw		0xff		
		movwf		0x52
CONT2:	decfsz		0x52,f
		goto		CONT2
		decfsz		0x51,f
		goto		CONT1
		decfsz		0x53,f
		goto		CONT
		return	
end